package com.redhat.jboss.support;

import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class HelloService implements HelloServiceMBean {

    //private String message = "Hello World!";
    private String message; 

    private ScheduledExecutorService pool = Executors.newScheduledThreadPool(1);
    private Runnable task;

    public void create() throws Exception {
        System.out.println("HelloService.create()");
    }

    public void start() throws Exception {
        System.out.println("HelloService.start()"); 

	System.out.println("start:" + task);
        if(task == null) {
            throw new IllegalStateException("Null task");
        }
    
        System.out.println(">>start:task=" + task);
        // pool.schedule(task, 1000, TimeUnit.MILLISECONDS);
        // pool.scheduleWithFixedDelay(task, 1000, 1000, TimeUnit.MILLISECONDS);
        pool.scheduleWithFixedDelay(task, 1000, 1000*10, TimeUnit.MILLISECONDS);
        System.out.println("<<start:task=" + task);

    }

    public void stop() throws Exception {
        System.out.println("HelloService.stop()");

        System.out.println("stop:" + task);
    
        System.out.println(">>stop");
        pool.shutdown();
        System.out.println("<<stop");
    }

    public void setTask(Runnable task) {
        System.out.println("HelloService.setTask(): " + task);
        this.task = task;
    }   

    public void destroy() throws Exception {
        System.out.println("HelloService.destroy()");
    }
    
    public void setMessage(String message) {
        System.out.println("HelloService.setMessage(): " + message);
        this.message = message; 
    }

    public String getMessage() {
        System.out.println("HelloService.getMessage(): " + message);
	return message;
    }

    public String hello() {
        System.out.println("HelloService.hello()");
	return message;
    }

}
