package com.redhat.jboss.support;

import java.util.HashMap;
import java.util.Map;

import javax.management.MBeanInfo;
import javax.management.MBeanServerConnection;
import javax.management.ObjectName;
import javax.management.remote.JMXConnector;
import javax.management.remote.JMXConnectorFactory;
import javax.management.remote.JMXServiceURL;

/**
 * @author <a href="mailto:mmiua@redhat.com">Masafumi Miura</a>
 * @since Sep 7, 2012
 */
public class JMXClient {

    public static void main(String[] args) throws Exception {

        String urlString = "service:jmx:remoting-jmx://" + System.getProperty("jmx.service.url", "localhost:9999");
        JMXServiceURL serviceURL = new JMXServiceURL(urlString);

        JMXConnector jmxConnector = JMXConnectorFactory.connect(serviceURL, null);

	// If JMX Connection is secured, please use the following instead of the above JMXConnectorFactory.connect().
	/*
        String[] credentials = {
               System.getProperty("jboss.admin.name", "admin"),
               System.getProperty("jboss.admin.password", "jboss") };

        Map<String, Object> env = new HashMap<String, Object>();
        env.put(JMXConnectorFactory.PROTOCOL_PROVIDER_PACKAGES, "org.jboss.remotingjmx.RemotingConnectorProvider");
        env.put(JMXConnector.CREDENTIALS, credentials);

        JMXConnector jmxConnector = JMXConnectorFactory.connect(serviceURL, env);
	*/

        try {
            MBeanServerConnection connection = jmxConnector.getMBeanServerConnection();

            //Get MBean count on the JBoss AS MBean server
	    System.out.println("MBeanCount = " + connection.getMBeanCount());

            //Invoke example MBean on the JBoss AS MBean server
	    String mbeanName = "example:type=HelloService,service=Hello";
	    ObjectName objectName = javax.management.ObjectName.getInstance(mbeanName);
	    String operation = "hello";
	    Object[] params = {};
	    String[] sig = {};
	    Object outcome = connection.invoke(objectName, operation, params, sig);
	    System.out.println("Invoke operation " + operation + " of MBean " + mbeanName + " -> " + outcome );
        } finally {
            jmxConnector.close();
        }

    }
}
